<template>
  <div class="home">
    <h1>รายวิชา</h1>
    <div v-for="day in sortDays" :key="day">
      <h4  v-if="!subjectIsNull">{{day}}</h4>
      <div v-for="subject in filterSubject(day)" :key="subject.subjectName">
        <div @click="onSubject">
          <Subject 
            :subjectName="subject.subjectName" 
            :location="subject.location" 
            :time="subject.time" 
            :bgColor="subject.bgColor">
          </Subject>
        </div>
      </div>
    </div>

    <center>
      <h4 v-if="subjectIsNull" style="margin-top: 5rem;color: gray;">ยังไม่ได้เพิ่มรายวิชา</h4>
    </center>

    <md-button class="md-icon-button float" @click="onAdd">
      <md-icon style="color: #000000DE; font-weight: bold;" class="md-size-2x">add</md-icon>
    </md-button>
  </div>
</template>

<script>
import Subject from '../components/Subject.vue'

export default {
  name: 'Home',
  metaInfo: {
    title: 'หน้าแรก'
  },
  components: {
    Subject
  },
  data: () => {
    return {
      days: ['จันทร์', 'อังคาร', 'พุธ', 'พฤหัสบดี', 'ศุกร์'],
      subjects: [
        {
          subjectName: 'USER EXPERIENCE AND USER INTERFACE DESIGN',
          location: 'Microsoft Teams',
          time: '13.00 - 16.00',
          bgColor: '#F2C511',
          day: 'พฤหัสบดี'
        },
        {
          subjectName: 'ENVIRONMENTAL STUDY',
          location: 'ตึกพระเทพ C-102',
          time: '13.00 - 16.00',
          bgColor: '#BB6DB9',
          day: 'ศุกร์'
        },
        {
          subjectName: 'LINEAR ALGEBRA',
          location: 'Microsoft Teams',
          time: '9.00 - 12.00',
          bgColor: '#EB5757',
          day: 'จันทร์'
        },
        {
          subjectName: 'STRATEGIC PLANNING USING BOARD AND CARD GAME',
          location: 'Zoom',
          time: '17.00 - 19.45',
          bgColor: '#F2994A',
          day: 'จันทร์'
        },
        {
          subjectName: 'INFORMATION COMPUTERSECURITY',
          location: 'Goole Meets',
          time: '10.00 - 15.00',
          bgColor: '#2D9CDB',
          day: 'อังคาร'
        },
        {
          subjectName: 'THEORY OF COMPUTATION',
          location: 'Goole Meets',
          time: '10.00 - 12.00',
          bgColor: '#27AE60',
          day: 'พุธ'
        }
      ]
    }
  },
  methods: {
    filterSubject(day) {
      if (this.subjects !== null) {
        return this.subjects.filter(subject => subject.day === day)
      }
    },
    onAdd() {
      this.$router.replace('/addsubject')
    },
    onSubject() {
      this.$router.replace('/subject')
    }
  },
  computed: {
    sortDays() {
      let day = new Date();
      day = day.toLocaleDateString('th-TH', { weekday: 'long' })
      day = day.substring(3)

      if(day === 'จันทร์'){
        return this.days
      }
      else if(day === 'อังคาร'){
        this.days.shift()
        this.days.push('จันทร์')
      }
      else if(day === 'พุธ'){
        this.days.shift()
        this.days.shift()
        this.days.push('จันทร์', 'อังคาร')
      }
      else if(day === 'พฤหัสบดี') {
        this.days.pop()
        this.days.pop()
        this.days.unshift('พฤหัสบดี', 'ศุกร์')
      }
      else if(day === 'ศุกร์') {
        this.days.pop()
        this.days.unshift('ศุกร์')
      }
      return this.days
    },
    subjectIsNull() {
      return this.subjects === null
    }
  }
}
</script>

<style lang="scss" scoped>

.float {
	position:fixed;
	width:60px;
	height:60px;
	bottom:30px;
	right:30px;
	background-color:white;
	color:#FFF;
	border-radius:50px;
	text-align:center;
	box-shadow: 2px 2px 3px rgba($color: #000000, $alpha: 0.3);
}

.float:hover {
  background-color: rgb(228, 228, 228);
}

้h4 {
  padding-top: 2rem;
}

h1 {
  font-size: 2.5rem;
}

.md-dialog-content, .md-dialog-title{
    max-width: 500px;
  }
</style>